#[derive(Debug, Clone)]
pub enum Node
{
    Nop,
    Number(i64),                                   // 숫자 값
    Expression(char, Box<Node>, Box<Node>),        // 계산식
    If(Box<Node>, Box<Vec<Node>>, Box<Vec<Node>>), // if문
    For(String, i64, i64, Box<Vec<Node>>),         // for문
    Print(Box<Node>),                              // print문(계산 출력)
    PrintString(String),                           // print문(문자열 출력)
    SetVariable(String, Box<Node>),                // 변수 대입
    GetVariable(String)                            // 변수 참조
}

impl Node
{
    pub fn expression(operator : char, left_value : Node, right_value : Node) -> Node
    {
        return Node::Expression(operator, Box::new(left_value), Box::new(right_value));
    }

    pub fn if_(condition_node : Node, true_node_vector : Vec<Node>, false_node_vector : Vec<Node>) -> Node
    {
        return Node::If(Box::new(condition_node), Box::new(true_node_vector), Box::new(false_node_vector));
    }
}